﻿using System.Drawing;
using Infragistics.Win;
using Infragistics.Win.UltraWinTree;

namespace infragistics_memory_test
{
    internal class TreeNodeBuilder
    {
        internal void BuildTreeNode(UltraTree ultraTree1_, TreeNodeColumns rdxNodeColumns_)
        {
            const int nodeLevel = 0;
            const int nodeLevelMax = 8;
            const int nodesPerLevel = 4;

            var node = new UltraTreeNode("RootNode", "RootNode");
            ultraTree1_.Nodes.Add(node);
            node.SetCellValue(rdxNodeColumns_.Name, "Root");
            BuildNextLevel(node, nodeLevel, nodesPerLevel, nodeLevelMax, rdxNodeColumns_);
        }

        private void BuildNextLevel(UltraTreeNode ultratreenode_, int nodeLevel_, int nodesPerLevel_, int nodeLevelMax_, TreeNodeColumns rdxNodeColumns_)
        {
            nodeLevel_++;
            for (int i = 0; i < nodesPerLevel_; i++)
            {
                var ultratreenodesub = new UltraTreeNode(null, "Node" + nodeLevel_ + i);
                ultratreenode_.Nodes.Add(ultratreenodesub);
                ultratreenodesub.SetCellValue(rdxNodeColumns_.Name, "Node" + nodeLevel_ + i);
                
                ultratreenodesub.Cells[rdxNodeColumns_.Column11].Appearance = MemConstants.StatusDisabledAppearance; // Memory Leak
                //ultratreenodesub.Cells[rdxNodeColumns_.Column11].Appearance = (AppearanceBase) MemConstants.StatusDisabledAppearance.Clone(); // No Memory Leak
                
                ultratreenodesub.Cells[rdxNodeColumns_.Column11].Appearance.BackColor = Color.DeepSkyBlue;
                if (nodeLevel_ >= nodeLevelMax_)
                {
                    return;
                }
                BuildNextLevel(ultratreenodesub, nodeLevel_, nodesPerLevel_, nodeLevelMax_, rdxNodeColumns_);
            }
        }
    }    
}